<template>
    <ObForm :form-data="formData" :form-model="formModel" :is-read-only="!isNew" @submit="onSubmitHandler" :dropdown-menu="dropdownMenu">
        <div class="row">
            <div class="col-xs-12">
                <ob-select
                    :label="dictionaryRu.modal.mask"
                    v-model="formData.maskUuid"
                    :items="maskFinalList"
                    :disabled="!isNew"
                    display-exp="mask"
                    value-exp="uuid"
                    :placeholder="dictionaryRu.modal.mask_placeholder"
                    property="maskUuid"
                />
            </div>
        </div>
        <div class="row resource-pattern-modal" v-if="formData.maskUuid && isNew">
            <div class="col-xs-12">
                <ob-input v-model="maskValue" :mask="mask" @on-mask-valid="onValid"/>
            </div>
        </div>
        <div class="row resource-pattern-modal" v-if="formData.maskUuid && !isNew">
            <div class="col-xs-12">
                <ob-input :value="displayValue" :disabled="true"/>
            </div>
        </div>
    </ObForm>
</template>

<script>
    import { STATUS_LIST } from '../../../resources/enum'
    import models from '@/models';
    import FormValidationMixin from 'common-components/src/obComponents/obForm/FormValidationMixin';
    import ObForm from "common-components/src/obComponents/obForm";
    import ObSelect from "common-components/src/obComponents/obSelect";
    import ObInput from "common-components/src/obComponents/obInput";
    import dropdownEvents from '@/mixins/dictionaries/dropdown-events'
    import { dictionary } from '@/translations/ru/dictionaries__resources__patterns';

    export default {
        name: "Pattern",
        components: {
            ObInput,
            ObSelect,
            ObForm,
        },
        mixins: [
            FormValidationMixin,
            dropdownEvents
        ],
        props: {
            maskList: {
                type: Array,
                default: () => []
            },
            dataSource: {
                type: Object,
                default: () => {}
            },
        },
        data() {
            return {
                dictionaryRu: dictionary,
                STATUS_LIST,
                maskValue: ''
            }
        },
        computed: {
            displayValue() {
                let maskValue = '';
                if (!this.isNew) {
                let mask = this.maskFinalList.find(m => m.uuid === this.formData.maskUuid);
                maskValue = mask.mask;
                for (let key in this.formData.parameters) {
                        maskValue = maskValue.replaceAll(key, this.formData.parameters[key])
                    }
                }
                return maskValue
            },
            maskFinalList(){
                let maskFinal =[];
                this.maskList.forEach((i) => {
                    let mask = i.mask.replace('м3','мЗ');
                    i.mask=mask;
                    maskFinal.push(i)
                });
                return maskFinal;
            },
            mask() {
                let mask = this.maskFinalList.find(m => m.uuid === this.formData.maskUuid);
                if (!mask) return '';
                let res = mask.mask;
                res = res.replace(RegExp('X', 'g'), '9');
                res = res.replace(RegExp('Y', 'g'), '9');
                res = res.replace(RegExp('Z', 'g'), '9');
                res = res.replace(RegExp('A', 'g'), '9');
                res = res.replace(RegExp('B', 'g'), '9');
                res = res.replace('м', 'm');
                return res;
            },
            activeParameters() {
                if(!this.isNew) {
                    return true;
                }
                else {
                    return !(this.formData.maskUuid);
                }
            },
            isNew () {
                return !this.formData.uuid;
            },
            formModel () {
                return models.patterns.add
            },
        },
        methods: {
            onSubmitHandler () {
                let data = _.cloneDeep(this.formData);
                this.$emit('submit', { formData: data, model: this.formModel })
            },
            onValid() {
                let mask = this.maskFinalList.find(m => m.uuid === this.formData.maskUuid);
                let characters = { A: 'A', B: 'B', X: 'X', Y: 'Y', Z: 'Z', E: 'E', '.': '.' };
                let value = this.maskValue.split('');
                let res = mask.mask;
                let buffer = '';
                let parameters = {};
                let currentMask = '';
                mask = mask.mask;
                mask += ' E';
                if (mask === 'XX у.маш E' || mask === 'ХХ у.ваг E') {
                    parameters = { '': '', XX: value.join('') }
                } else {
                    mask.split('').forEach((val) => {
                        if (characters[val]) {
                            if ((currentMask[currentMask.length - 1] === val || currentMask[currentMask.length - 1] === '.') && val !== '.') {
                                currentMask += val;
                                buffer += value[0];
                                res = res.replace(val, value[0]);
                                value.shift()
                            } else if (val !== '.') {
                                parameters[currentMask] = buffer;
                                buffer = '';
                                buffer += value[0];
                                currentMask = val;
                                res = res.replace(val, value[0]);
                                value.shift()
                            } else {
                                currentMask += val;
                                buffer += '.'
                            }

                        }
                    })
                }
                this.formData.parameters = {};
                for(let key in parameters) {
                    if (key) this.formData.parameters[key] = parameters[key]
                }
            }
        },
    }
</script>

<style lang="scss" scoped>

.expression {
    margin-top: 20px;
}
.resource-pattern-modal {
    .col-xs-2 {
        max-width: 110px
    }
    .col-xs-3 {
        max-width: 192px
    }
}

</style>
